<!DOCTYPE html>
<html>
    <head>
        <title>Session3</title>
    </head>
    <body>
        <script>
            //closure
            function ref_fun(ele){
                return (function ref_infun(ele1){
                    return ele + ele1;
                });
            }
            var res = ref_fun(5);
            document.write(res(10)+"<br>");
            var res1 = res;
            document.write("res1 = " + res1(5));
            var res2 = res.bind(res);
            document.write("<br>res2 = " + res2(10));

            //arrays
            var arr = [1,"script",null,4.5,,]; // Array can take any type elements
            document.write("<br>"+arr); // array accepts null and displayed as empty
            var arr_join = arr.join(" * ");
            document.write("<br>"+arr_join);
            
            var obj_arr = [{
                fname : "pavani",
                lname : "kotamarthi"
            },{
                gender : "female",          // array accepts objects
                age : 21
            },{
                place : "hyd",
                phno : 94440
            }];
            document.write("<br>"+obj_arr);
            document.write("<br>"+obj_arr[0].fname);
            document.write("<br>"+obj_arr[1].gender);
            var arr_obj_join = obj_arr.join(" $ ");
            document.write("<br>"+arr_obj_join+"<br>");
            //foreach() method
            var arr_method1 = [0,-2,6,-1,1];
            document.write("for each output : <br>")
            arr_method1.forEach(display);
            function display(item,index){
                document.write(item + " : " + index + "<br>");
            }
            //filter() method
            document.write("Filter output<br>"+arr_method1.filter(pos_arr)+"<br>"); // returns array that pass the condition
            function pos_arr(arr_method1){
                return arr_method1>0;
            }
            //reduce() method
            document.write("reduce output<br>"+arr_method1.reduce(sum_arr)+"<br>"); // reduce returns a single value
            function sum_arr(sum,val){
                return sum + val;
            }
            //push and pop
            arr_method1.push(2);
            document.write("Pushed value: "+ arr_method1); // value added at the end
            arr_method1.pop();
            document.write("<br>Pop : "+arr_method1); // value removed at the end
            //shift and unshift
            arr_method1.unshift(5);
            document.write("<br>Unshifted: "+arr_method1); // value added at beginning
            arr_method1.shift();
            document.write("<br>Shifted: "+arr_method1); // value deleted at beginning
            //map() method
            var arr_method1_map = arr_method1.map(pos_to_neg); // returns an array after performing operations on the array elements
            document.write("<br>Map: "+arr_method1_map);
            function pos_to_neg(value){
                return value*-1;
            }
            //using map and reduce
            var arr = [1,[1,2],[1,2,[1,2,3]]];
            document.write("<br>Array index not declared value: "+arr[4]);
            var dup_arr = [];
            document.write("<br> map_red"+arr.map(function map_fun(item){
                    if(Array.isArray(item)){
                        return item.map(map_fun);
                    }
                    dup_arr.push(item);
                    return item;
                }).reduce(red_func,0));
            function red_func(total,element){
                return total + element;
            }
            document.write("<br> dup arr reduce "+dup_arr.reduce(red_func));
            //using flat and reduce
            var arr_flat = arr.flat(2);
            document.write("<br>arr flat "+arr_flat);
            document.write("<br>reduce "+arr_flat.reduce(reduce_fun));
            function reduce_fun(acc,val){
                return acc+val;
            }
            // functions in arrays
            var arr_funs = [function(){
                document.write("functions in array");
            }, "java script"];
            document.write("<br>fun in arr 0 : " );
            arr_funs[0]();
        </script>
    </body>
</html>